;------ MAIN ------------------------------------------------------- CBMprgStudio 3.9.0

;       (c) wertstahl 05/2018 | "it is a beautiful day, and then you die."
;

;------ BASIC - bootloader ------------------------------------------------------------

*=$0801
            byte  $0c,$08,$01,$00,$9e,$20,$32,$30,$36,$32,$00,$00,$00; 0 sys2062 ($080e)

*=$080e
            jmp   appstart

;-------------------------------------------------------------------------------------

appstart    cld
            sei

            lda   #$01
            sta   $d01a
            sta   $dc0d

            lda   #$35
            sta   $01

            jsr   tools

            lda   #$1b
            sta   $d011     

            lda   #$c0
            sta   $d016

            lda   #<mainloop
            sta   $FFFE
            ldy   #>mainloop
            sty   $FFFF


            lda   firstscan   ; first interrupt line
            sta   $d012
            lda   #$7f
            sta   $dc0d
            lda   $dc0d       
            
            cli

            jsr   drawdom

;------------------------------------------------------

idle        

            lda   $dc01
            cmp   #$ff        ; check space pressed
            beq   idle
           ; pha

            jsr   drawdom

            jsr   blur

            ;pla
debounce    ;cmp   $dc01
            ;beq   debounce

            jmp   idle

;            jmp   wrapup


;--------------------------------------------------------------------------------------------------------------------
;====================================================================================================================
;--------------------------------------------------------------------------------------------------------------------

firstscan    = #$ee   


mainloop    pha
            txa
            pha
            tya
            pha


            inc   $d019
            lda   $dc0d

            inc   $d020
            inc   $d021
            ldx   $d012
            inx
waither     cpx   $d012
            beq   waither
            dec   $d020
            dec   $d021

            lda   firstscan
            sta   $d012
reentry     pla
            tay
            pla
            tax
            pla
            rti

            ;-----------------


;--------------------------------------------------------------------------------------------------------------------
;====================================================================================================================
;--------------------------------------------------------------------------------------------------------------------


drawdom     ldx   #$00
paintle     
            lda   $dc01
            eor   $d800
            sta   $db00
            eor   $db00

            eor   $0400,x
            adc   $d800,x

            sta   $0400,x

            inx
            bne   paintle

            rts

;-------------------------------------------------

floorvals   ldy   #$00
floord      ldx   $0400,y

            dex
            bmi   skip1

            txa
            sta   $0400,y

skip1       ldx   $0500,y
            
            dex
            bmi   skip2

            txa
            sta   $0500,y

skip2
           ; lda   flooring,x
           ; sta   $0400,y
           ; ldx   $0500,y
           ; lda   flooring,x
           ; sta   $0500,y

            iny
            bne   floord
            rts

;-------------------------------------------------


flooring    byte   $00
            byte   $00,$01,$02,$03, $04,$05,$06,$07, $08,$09,$0a,$0b, $0c,$0d,$0e,$0f
            byte   $10,$11,$12,$13, $14,$15,$16,$17, $18,$19,$1a,$1b, $1c,$1d,$1e,$1f
            byte   $20,$21,$22,$23, $24,$25,$26,$27, $28,$29,$2a,$2b, $2c,$2d,$2e,$2f
            byte   $30,$31,$32,$33, $34,$35,$36,$37, $38,$39,$3a,$3b, $3c,$3d,$3e,$3f

            byte   $40,$41,$42,$43, $44,$45,$46,$47, $48,$49,$4a,$4b, $4c,$4d,$4e,$4f
            byte   $50,$51,$52,$53, $54,$55,$56,$57, $58,$59,$5a,$5b, $5c,$5d,$5e,$5f
            byte   $60,$61,$62,$63, $64,$65,$66,$67, $68,$69,$6a,$6b, $6c,$6d,$6e,$6f
            byte   $70,$71,$72,$73, $74,$75,$76,$77, $78,$79,$7a,$7b, $7c,$7d,$7e,$7f

            byte   $80,$81,$82,$83, $84,$85,$86,$87, $88,$89,$8a,$8b, $8c,$8d,$8e,$8f
            byte   $90,$91,$92,$93, $94,$95,$96,$97, $98,$99,$9a,$9b, $9c,$9d,$9e,$9f
            byte   $a0,$a1,$a2,$a3, $a4,$a5,$a6,$a7, $a8,$a9,$aa,$ab, $ac,$ad,$ae,$af
            byte   $b0,$b1,$b2,$b3, $b4,$b5,$b6,$b7, $b8,$b9,$ba,$bb, $bc,$bd,$be,$bf

            byte   $c0,$c1,$c2,$c3, $c4,$c5,$c6,$c7, $c8,$c9,$ca,$cb, $cc,$cd,$ce,$cf
            byte   $d0,$d1,$d2,$d3, $d4,$d5,$d6,$d7, $d8,$d9,$da,$db, $dc,$dd,$de,$df
            byte   $e0,$e1,$e2,$e3, $e4,$e5,$e6,$e7, $e8,$e9,$ea,$eb, $ec,$ed,$ee,$ef
            byte   $f0,$f1,$f2,$f3, $f4,$f5,$f6,$f7, $f8,$f9,$fa,$fb, $fc,$fd,$fe,$ff

;-------------------------------------------------

                                    
gamma       
            byte   $00,$00,$00,$00, $00,$00,$00,$00, $00,$00,$00,$00, $00,$00,$00,$00
            byte   $00,$00,$00,$00, $00,$00,$00,$00, $00,$00,$00,$00, $00,$00,$00,$00
            byte   $00,$00,$00,$00, $00,$00,$00,$00, $00,$00,$00,$00, $00,$00,$00,$00
            byte   $00,$00,$00,$00, $00,$00,$00,$00, $00,$00,$00,$00, $00,$00,$00,$00
            byte   $00,$01,$02,$03, $04,$05,$06,$07, $08,$09,$0a,$0b, $0c,$0d,$0e,$0f
            byte   $10,$11,$12,$13, $14,$15,$16,$17, $18,$19,$1a,$1b, $1c,$1d,$1e,$1f
            byte   $20,$21,$22,$23, $24,$25,$26,$27, $28,$29,$2a,$2b, $2c,$2d,$2e,$2f
            byte   $30,$31,$32,$33, $34,$35,$36,$37, $38,$39,$3a,$3b, $3c,$3d,$3e,$3f

            byte   $40,$41,$42,$43, $44,$45,$46,$47, $48,$49,$4a,$4b, $4c,$4d,$4e,$4f
            byte   $50,$51,$52,$53, $54,$55,$56,$57, $58,$59,$5a,$5b, $5c,$5d,$5e,$5f
            byte   $60,$61,$62,$63, $64,$65,$66,$67, $68,$69,$6a,$6b, $6c,$6d,$6e,$6f
            byte   $70,$71,$72,$73, $74,$75,$76,$77, $78,$79,$7a,$7b, $7c,$7d,$7e,$7f

            byte   $80,$81,$82,$83, $84,$85,$86,$87, $88,$89,$8a,$8b, $8c,$8d,$8e,$8f
            byte   $90,$91,$92,$93, $94,$95,$96,$97, $98,$99,$9a,$9b, $9c,$9d,$9e,$9f
            byte   $a0,$a1,$a2,$a3, $a4,$a5,$a6,$a7, $a8,$a9,$aa,$ab, $ac,$ad,$ae,$af
            byte   $b0,$b1,$b2,$b3, $b4,$b5,$b6,$b7, $b8,$b9,$ba,$bb, $bc,$bd,$be,$bf

            byte   $c0,$c1,$c2,$c3, $c4,$c5,$c6,$c7, $c8,$c9,$ca,$cb, $cc,$cd,$ce,$cf
            byte   $d0,$d1,$d2,$d3, $d4,$d5,$d6,$d7, $d8,$d9,$da,$db, $dc,$dd,$de,$df
            byte   $e0,$e1,$e2,$e3, $e4,$e5,$e6,$e7, $e8,$e9,$ea,$eb, $ec,$ed,$ee,$ef
            byte   $f0,$f1,$f2,$f3, $f4,$f5,$f6,$f7, $f8,$f9,$fa,$fb, $fc,$fd,$fe,$ff





stor        byte $0

datafield   = $05e0

            ;================

blur        ldx #$00

            ;----------------<<

dupdata     lda $0400,x                   ;copy data to working matrix
            sta datafield,x
            inx
            bne dupdata
            
            ldx #$00
            ldy #$03

            ;----------------<<

do_blur     clc
            lda datafield+1,x
            adc datafield+2,x
            ror
            sta datafield+2,x

            inx
            cpx #$00
            bne do_blur

            dey
            bne do_blur

            rts

            ;================


;-------------------------------------------------

incasm      "tools.asm"

;-------------------------------------------------
;-------------------------------------------------
;-------------------------------------------------
;EOF
